/*
Copyright (c) 2007-2012 Alloysoft, LLC. All rights reserved.
http://www.alloysoft.com
*/
var uiMonitorId=0;
var loggingEnabled=true;
var isMobileSafari=true;
var isTouchCapable=true;
var isIPad=true;
var lastPlaylistPosition=-1;
var currentBrowsePath="";
var currentSearchKeywords="";
var currentArtURL="";
var searchInput="";
var searchInputTimer;
var lastPlaybackUpdateTime;
var lastPlaybackPostTime=new Date();
var playbackPosition=0;
var lastPlaybackPosition=null;
var lastPostedPlaybackPosition=0;
var lastMediaItemLength=0;
var pendingPlaybackPostPosition=0;
var playbackTimerId=0;
var playbackPostTimerId=0;
var isPlaying=false;
var showingMediaLib=false;
var showingPlaylist=false;
var showingSpeakers=false;
var showingSearchResults=false;
var showingMediaLibSearch=false;
var showingMediaLibActions=false;
var showingMediaLibAlphaJump=false;
var showingMediaLibSearchResults=false;
var showingSubControls=false;
var timeElapsedElem;
var timeRemainingElem;
var itemsPerPage=13;
var volumeIncrement=10;
var slideSpeed=4;
var mediaLibStart=0;
var mediaLibLength=0;
var playlistStart=0;
var playlistLength=0;
var showPlaylistItemOnPageLoad=false;
var browseHistory=new Array();
var currentActionItem="";
var useMultipleSpeakers=false;
var albumArtCurrentName="albumart";
var albumArtNewName="albumart2";
var playbackSlider;
var volumeSlider;
var navHistory=new Array();
var navHash="#";
var navCurrent="";

BrowseHistoryEntry=function()
{this.path="";this.search=false;this.start=0};

function onConnectedToPlayer()
{player.browseLibrary(currentBrowsePath,mediaLibStart,itemsPerPage);
player.getPlaylistItems(0,itemsPerPage);
timeElapsedElem=document.getElementById("time_elapsed");
timeRemainingElem=document.getElementById("time_remaining")}

function onCurrentMediaChanged(A)
{var B=document.getElementById("artist");
B.innerHTML=A.artist;B=document.getElementById("album");
B.innerHTML=A.album;B=document.getElementById("title");
B.innerHTML=A.title;if(A.length!=lastMediaItemLength){updatePlaybackPosition(playbackPosition);
lastPlaybackUpdateTime=new Date()}}

function onPlayingStateChanged(C)
{var B='<img src="images/ctrl_play.png">';
if(C=="playing"){B='<img src="images/ctrl_pause.png">'}message=document.getElementById("ctrl_play");
message.innerHTML=B;
var A=(C=="playing");
if(isPlaying!=A){if(A){isPlaying=true;
lastPlaybackUpdateTime=new Date();
playbackTimerId=setInterval(incrementPlaybackPosition,500)}else{isPlaying=false;
clearInterval(playbackTimerId);
playbackTimerId=0}}}function onVolumeChanged(A){volumeSlider.setPos(A/100)}

function onPlaylistChanged()
{player.getPlaylistItems(playlistStart,itemsPerPage)}

function onPlaylistPositionChanged(A)
{var C=document.getElementById("playlist_"+lastPlaylistPosition);
if(C){C.className=""}C=document.getElementById("playlist_"+A);
if(C){C.className="playing"}lastPlaylistPosition=A;
if(!showingPlaylist){if(A<playlistStart||A>(playlistStart+itemsPerPage)){var B=parseInt(A/itemsPerPage);
player.getPlaylistItems(B*itemsPerPage,itemsPerPage)}}}

function onPlaybackPositionChanged(A)
{if(!playbackSlider.isDragging){updatePlaybackPosition(A*1000);
lastPlaybackUpdateTime=new Date()}}

function updatePlaybackPosition(A,D)
{var B=player.currentMedia.length;
playbackPosition=A;
A=parseInt(A/1000);
if(A>B){A=B}if(A!==lastPlaybackPosition||B!=lastMediaItemLength){lastPlaybackPosition=A;
lastMediaItemLength=B;
var C=B-A;
if(C<0){C=0}timeElapsedElem.innerHTML=formatTime(A);
timeRemainingElem.innerHTML="-"+formatTime(C);
if(!D){playbackSlider.setPos(B>0?(A/B):0)}}}

function incrementPlaybackPosition()
{var B=new Date();
var A=B-lastPlaybackUpdateTime;
updatePlaybackPosition(playbackPosition+A);lastPlaybackUpdateTime=B}function formatTime(E){var A="";var C=1;var B=parseInt(E/3600);E-=B*3600;var D=parseInt(E/60);E-=D*60;if(B>0){A+=B+":";C=2}A+=addLeadingZeros(D,C)+":"+addLeadingZeros(E,2);return A}function addLeadingZeros(B,C){var A=""+B;while(A.length<C){A="0"+A}return A}function onShuffleStateChanged(A){var B=document.getElementById("shufflecontrol");if(B){if(A){B.style.background='url("images/shuffle_on.png") center no-repeat'}else{B.style.background='url("images/shuffle_off.png") center no-repeat'}}}function onRepeatStateChanged(B){var A=document.getElementById("repeatcontrol");if(A){if(B){A.style.background='url("images/repeat_on.png") center no-repeat'}else{A.style.background='url("images/repeat_off.png") center no-repeat'}}}function onSpeakerListChanged(B){var A=document.getElementById("speakercontrolcontainer");var E=document.getElementById("speakerlist");var F="";for(var D=0;D<B.length;D++){var C=B[D];F+='<li onclick="handleSpeakerSelection('+C.id+')">'+C.name+"</li>"}E.innerHTML=F;if(B.length>1){A.style.display="block"}else{A.style.display="none"}}function onMediaLibraryChanged(){player.browseLibrary(currentBrowsePath,0,itemsPerPage)}function onResponseError(A){if(A==PlayerError.UIScriptingDisabled){alert('Please check "Enable access for assistive devices" on your Mac to use this feature.')}}function onBrowseLibraryResponse(C){var G="<ul>";var L;var H="";var M="";var J=false;var K=false;var F="";if(showingMediaLibAlphaJump){showMediaLibAlphaJump()}if(showingMediaLibSearch){showMediaLibSearch()}if(showingMediaLibSearchResults){showingMediaLibSearchResults=false}if(showingMediaLib){hideAddressBar()}showingSearchResults=false;currentBrowsePath=C.path;var A="Media Library";if(currentBrowsePath.length>1){var I=currentBrowsePath.lastIndexOf("/");if(I!=-1){I++;A=decodeURIComponent(currentBrowsePath.substr(I,currentBrowsePath.length-I));if(A.length>0){if(A.charAt(A.length-1)=="/"){A=A.substr(0,A.length-1)}}else{A="Media Library"}}}A=escapeHtmlEntities(A);if(document.getElementById){message=document.getElementById("libheadertitle");message.innerHTML=A}else{libheadertitle.innerHTML=A}if(C.start!==null){mediaLibStart=C.start}if(C.totalCount!==null&&C.totalCount>=0){mediaLibLength=C.totalCount}if(mediaLibLength>itemsPerPage){G+="<li>";if(mediaLibStart>0){G+='<div id="navprev" onclick="mediaLibPrevPage()">&lt; zurück</div>'}else{G+='<div id="navprev">&nbsp;</div>'}G+='<div id="navalphajump" onclick="showMediaLibAlphaJump()">A-Z</div>';if((mediaLibStart+itemsPerPage)<mediaLibLength){G+='<div id="navnext" onclick="mediaLibNextPage()">vor &gt;</div>'}else{G+='<div id="navnext">&nbsp;</div>'}G+="</li>"}for(var D=0,B=C.items.length;D<B;D++){L=C.items[D];H=L.type;J=false;K=true;if(L.type=="folder"){J=true}var A=L.title;if(J){if(A=="Music"){M="cd"}else{if(A=="Videos"){M="video"}else{if(A=="TV"){M="tv"}else{if(A=="Genres"){M="genre"}else{if(A=="Artists"){M="artist"}else{if(A=="Albums"){M="album"}else{if(A=="Playlists"){M="playlist"}else{if(A=="Songs"){M="music"}else{if(A=="Podcasts"){M="podcast"}else{if(A=="Radio"){M="podcast"}else{M="music"}}}}}}}}}}}else{if(H=="genre"){M="genre"}else{if(H=="artist"){M="artist"}else{if(H=="album"){M="album"}else{if(H=="podcast_show"){M="podcast"}else{if(H=="tv_series"){M="artist";K=false}else{if(H=="playlist"){M="playlist"}else{if(H=="playlist_folder"||H=="radio_folder"){M="playlist_folder";K=false}else{if(H=="info"){M="info"}else{M="music"}}}}}}}}}F=currentBrowsePath+"/"+encodeURIComponent(A);F=F.replace(/'/gmi,"\\'");G+='<li id="medialib_'+(mediaLibStart+D)+'" ';if(L.container){if(!J&&K){G+='class="group" '}}else{if(H=="music"||H=="podcast"){G+='><div id="grouptitle"'}}if(!L.container){G+='onclick="handlePlayItem(this, '+L.mediaId+')"'}else{G+="onclick=\"handleBrowseLibrary(this, '"+F+"')\""}G+=">";if(M!=""){G+='<img src="images/'+M+'.png">'}G+=A;if(L.container){if(!J&&K){G+='<div id="showactions" onclick="showMediaLibActions(\''+F+"')\"></div>"}}else{if(H=="music"||H=="podcast"){G+='</div><div id="showactions" onclick="handleSingleItemAdd(this, '+L.mediaId+')"></div>'}}G+="</li>"}if(mediaLibLength>itemsPerPage){G+="<li>";if(mediaLibStart>0){G+='<div id="navprev" onclick="mediaLibPrevPage()">&lt; zurück</div>'}else{G+='<div id="navprev">&nbsp;</div>'}G+='<div id="navalphajump" onclick="showMediaLibAlphaJump()">A-Z</div>';if((mediaLibStart+itemsPerPage)<mediaLibLength){G+='<div id="navnext" onclick="mediaLibNextPage()">vor &gt;</div>'}else{G+='<div id="navnext">&nbsp;</div>'}G+="</li>"}G+="</ul>";if(document.getElementById){message=document.getElementById("libcontents");message.innerHTML=G}if(C.scrollToIndex!=-1&&showingMediaLib){var E=document.getElementById("medialib_"+C.scrollToIndex);if(E){slideTo(E.offsetTop)}}}function onSearchLibraryResponse(B){var E="<ul>";var I;var D="";if(!showingMediaLibSearchResults){addBrowseHistoryEntry();showingMediaLibSearchResults=true;if(document.getElementById){message=document.getElementById("libheadertitle");message.innerHTML="Search"}else{libheadertitle.innerHTML="Search"}}mediaLibStart=B.start;if(B.totalCount!==null&&B.totalCount>=0){mediaLibLength=B.totalCount}for(var C=0,A=B.items.length;C<A;C++){item=B.items[C];var F=item.type;var G="music";var H="music";D="";G=item.type;if(G=="podcast_show"){G="podcast"}else{if(G=="podcast"){G="music"}}E+="<li";if(!item.container){if(F!="playlist"){E+='><div id="grouptitle" onclick="handlePlayItem(this, '+item.mediaId+')"'}else{E+=' onclick="handlePlayItem(this, '+item.mediaId+')"'}}else{D="/Music/";if(F=="genre"){D+="Genres/"}else{if(F=="artist"){D+="Artists/"}else{if(F=="album"){D+="Albums/"}else{if(F=="podcast_show"){D="/Podcasts/"}}}}D+=encodeURIComponent(item.title);D=D.replace(/'/gmi,"\\'");E+=' class="group" onclick="handleBrowseLibrary(this, \''+D+"')\""}E+='><img src="images/'+G+'.png">'+item.title;if(item.container){E+='<div id="showactions" onclick="showMediaLibActions(\''+D+"')\"></div>"}else{if(F!="playlist"){E+='</div><div id="showactions" onclick="handleSingleItemAdd(this, '+item.mediaId+')"></div>'}}E+="</li>"}E+="</ul>";if(document.getElementById){message=document.getElementById("libcontents");message.innerHTML=E}else{libcontents.innerHTML=E}showingSearchResults=true}function onGetPlaylistItemsResponse(A){var B=0;var D="<ul>";if(showingPlaylist){hideAddressBar()}playlistStart=A.start;if(A.totalCount!==null&&A.totalCount>=0){playlistLength=A.totalCount}if(playlistLength>itemsPerPage){D+="<li>";if(playlistStart>0){D+='<div id="navprev" onclick="playlistPrevPage()">&lt; zurück</div>'}if((playlistStart+itemsPerPage)<playlistLength){D+='<div id="navnext" onclick="playlistNextPage()">vor &gt;</div>'}D+="</li>"}for(i=0,length=A.items.length;i<length;i++){var C=A.items[i];B=playlistStart+i;D+='<li id="playlist_'+B+'" onclick="handlePlaylistJump(this, '+B+')"';if(B==player.playlistPosition){D+='class="playing" '}D+=">"+C.title+' <span class="listArtist">'+C.artist+"</span></li>"}if(A.items.length<1){D+="<li>No items</li>"}if(playlistLength>itemsPerPage){D+="<li>";if(playlistStart>0){D+='<div id="navprev" onclick="playlistPrevPage()">&lt; zurück</div>'}if((playlistStart+itemsPerPage)<playlistLength){D+='<div id="navnext" onclick="playlistNextPage()">vor &gt;</div>'}D+="</li>"}D+="</ul>";if(document.getElementById){message=document.getElementById("playlistcontents");message.innerHTML=D}else{playlist.innerHTML=D}if(showPlaylistItemOnPageLoad){showPlaylistItemOnPageLoad=false;if(player.playlistPosition>=playlistStart&&player.playlistPosition<(playlistStart+itemsPerPage)){showCurrentPlaylistItem()}}}function requestInitialState(){sendRequest("<GetCurrentStateRequest></GetCurrentStateRequest>");sendRequest("<GetSpeakerListRequest></GetSpeakerListRequest>");player.browseLibrary(currentBrowsePath,mediaLibStart,itemsPerPage);player.getPlaylistItems(0,itemsPerPage)}

function testForMobileSafari()
{try
{
if(navigator.userAgent)
	{var B=navigator.userAgent.indexOf(" Mobile/");
		if(B!=-1){B=navigator.userAgent.indexOf(" Safari/");
		if(B!=-1){B=navigator.userAgent.indexOf("iPad");
		if(B!=-1){isIPad=true;
			return false}
	return true}
}
}
}catch(A)
{}return false}

function onLoad()
{isMobileSafari=testForMobileSafari();
player.navigatorOnlineEnabled=isMobileSafari;
isTouchCapable=("ontouchstart" in document.documentElement);

if(window.devicePixelRatio)
	{player.albumArtSize=player.albumArtSize*parseInt(window.devicePixelRatio)}
if(isMobileSafari&&location.hash!=navCurrent&&location.hash!="NowPlaying")
	{navCurrent="NowPlaying";
	location.hash=navCurrent}uiMonitor();

var A=document.getElementById(albumArtCurrentName);

if(A&&A.addEventListener){A.addEventListener("webkitTransitionEnd",onAlbumArtAnimationEnd,false)}if(document.body.addEventListener){document.body.addEventListener("offline",function(){updateOnlineState("offline")},false);document.body.addEventListener("online",function(){updateOnlineState("online")},false)}playbackSlider=new Slider("scrubbercontrol",function(C){var B=new Date();var D=parseInt(lastMediaItemLength*C);if(D!=lastPlaybackPosition){updatePlaybackPosition(D*1000,true);if(B-lastPlaybackPostTime>500){if(playbackPostTimerId!=0){clearTimeout(playbackPostTimerId);playbackPostTimerId=0}player.setPlaybackPosition(D);lastPostedPlaybackPosition=D;lastPlaybackPostTime=B;lastPlaybackUpdateTime=B}else{pendingPlaybackPostPosition=D;if(playbackPostTimerId==0){playbackPostTimerId=setTimeout(function(){playbackPostTimerId=0;if(Math.abs(pendingPlaybackPostPosition-lastPostedPlaybackPosition)>10){player.setPlaybackPosition(pendingPlaybackPostPosition);lastPostedPlaybackPosition=pendingPlaybackPostPosition;lastPlaybackPostTime=new Date();lastPlaybackUpdateTime=lastPlaybackPostTime}},500)}}}});volumeSlider=new Slider("volumecontrol",function(B){var C=parseInt(B*100);if(C!=player.volume){player.setVolume(C)}});player.onConnectedToPlayer=onConnectedToPlayer;player.onCurrentMediaChanged=onCurrentMediaChanged;player.onAlbumArtChanged=onAlbumArtChanged;player.onRatingChanged=onRatingChanged;player.onPlayingStateChanged=onPlayingStateChanged;player.onShuffleStateChanged=onShuffleStateChanged;player.onRepeatStateChanged=onRepeatStateChanged;player.onVolumeChanged=onVolumeChanged;player.onPlaylistChanged=onPlaylistChanged;player.onPlaylistPositionChanged=onPlaylistPositionChanged;player.onPlaybackPositionChanged=onPlaybackPositionChanged;player.onSpeakerListChanged=onSpeakerListChanged;player.onResponseError=onResponseError;player.onMediaLibraryChanged=onMediaLibraryChanged;player.onBrowseLibraryResponse=onBrowseLibraryResponse;player.onSearchLibraryResponse=onSearchLibraryResponse;player.onGetPlaylistItemsResponse=onGetPlaylistItemsResponse;setTimeout(setupApp,100)}function updateOnlineState(A){if(isMobileSafari){if(A=="offline"){if(uiMonitorId){clearInterval(uiMonitorId);uiMonitorId=0}}else{uiMonitorId=setInterval(uiMonitor,300)}}}function setupApp(){hideAddressBar();player.start();if(isMobileSafari){uiMonitorId=setInterval(uiMonitor,300)}var A=getCookie("useMultipleSpeakers");if(A!=null&&A=="true"&&!useMultipleSpeakers){toggleUseMultipleSpeakers()}}function Slider(C,B){var A=this;this.lastEventPos=0;this.isDragging=false;this.onDrag=B;this.slider=document.getElementById(C+"_slider");this.overlay=document.getElementById(C+"_on");this.base=document.getElementById(C);this.currentX=0;this.sliderOffset=6;this.maxX=this.overlay.offsetWidth-this.sliderOffset;this.setPos=function(D){if(!this.isDragging){this.moveTo(parseInt(this.maxX*D))}};this.moveTo=function(E){var D=0;if(E<0){D=E;E=0}else{if(E>this.maxX){D=E-this.maxX;E=this.maxX}}this.slider.style.left=(E-this.sliderOffset)+"px";this.overlay.style.width=E+"px";this.currentX=E;return D};this.onTouchStart=function(D){if(D.touches.length!=1){return false}this.isDragging=true;this.lastEventPos=D.touches[0].clientX;this.slider.addEventListener("touchmove",this,false);this.slider.addEventListener("touchend",this,false)};this.onTouchEnd=function(D){this.isDragging=false;this.slider.removeEventListener("touchmove",this,false);this.slider.removeEventListener("touchend",this,false)};this.onMouseDown=function(D){this.isDragging=true;this.lastEventPos=D.clientX;window.addEventListener("mousemove",this,false);window.addEventListener("mouseup",this,false);this.base.removeEventListener("click",this,false);this.overlay.removeEventListener("click",this,false)};this.onMouseUp=function(D){this.isDragging=false;window.removeEventListener("mousemove",this,false);window.removeEventListener("mouseup",this,false);if(!isTouchCapable&&D.offsetX!==undefined){setTimeout(function(){A.base.addEventListener("click",A,false);A.overlay.addEventListener("click",A,false)},1)}};this.onMove=function(F){var D=F.touches!==undefined?F.touches[0].clientX:F.clientX;var E=this.moveTo(this.currentX+(D-this.lastEventPos));this.lastEventPos=D-E;if(this.onDrag){this.onDrag(this.currentX/this.maxX)}};this.onClick=function(E){if(E.offsetX===undefined){return }var D=E.offsetX;this.moveTo(D);if(this.onDrag){this.onDrag(this.currentX/this.maxX)}};this.handleEvent=function(D){switch(D.type){case"touchstart":this.onTouchStart(D);break;case"touchmove":this.onMove(D);break;case"touchend":this.onTouchEnd(D);break;case"mousedown":this.onMouseDown(D);break;case"mousemove":this.onMove(D);break;case"mouseup":this.onMouseUp(D);break;case"click":this.onClick(D);break;default:return }if(D.preventDefault){D.preventDefault()}else{D.returnValue=false}};this.handleEventIE=function(D){A.handleEvent.call(A,D)};this.addEventListener=function(E,D){if(E.addEventListener){E.addEventListener(D,this,false)}else{if(E.attachEvent){E.attachEvent("on"+D,this.handleEventIE)}}};if(this.slider.addEventListener){this.slider.addEventListener("touchstart",this,false);this.slider.addEventListener("mousedown",this,false)}if(!isTouchCapable){this.addEventListener(this.base,"click");this.addEventListener(this.overlay,"click")}this.setPos(0)}function hideAddressBar(){window.scrollTo(0,1)}function backToNowPlaying(){if(showingMediaLib){showMediaLib(false)}else{if(showingPlaylist){showPlaylist(false)}else{if(showingSpeakers){showSpeakers(false)}}}}function showMediaLib(B){if(document.getElementById){hideAddressBar();var C=document.getElementById("medialib");var A=document.getElementById("container");if(!showingMediaLib){setLocation("Media",B);if(showingPlaylist){showPlaylist()}showingMediaLib=true;C.style.overflow="visible";C.style.visibility="visible";A.style.overflow="visible"}else{if(showingMediaLibSearch){showMediaLibSearch()}if(showingMediaLibAlphaJump){showMediaLibAlphaJump()}showingMediaLib=false;C.style.overflow="hidden";A.style.overflow="hidden";if(isIPad){setTimeout(function(){C.style.visibility="hidden"},0)}else{C.style.visibility="hidden"}}}}function showPlaylist(B){if(document.getElementById){var C=document.getElementById("playlist");var A=document.getElementById("container");if(!showingPlaylist){setLocation("Playlist",B);if(showingMediaLib){showMediaLib(false)}hideAddressBar();C.style.overflow="visible";C.style.visibility="visible";A.style.overflow="visible";showingPlaylist=true}else{C.style.overflow="hidden";A.style.overflow="hidden";if(isIPad){setTimeout(function(){C.style.visibility="hidden"},0)}else{C.style.visibility="hidden"}showingPlaylist=false;hideAddressBar()}}}function showSpeakers(C){if(document.getElementById){var B=document.getElementById("speakers");var A=document.getElementById("container");if(!showingSpeakers){setLocation("Speakers",C);hideAddressBar();B.style.overflow="visible";B.style.visibility="visible";A.style.overflow="visible";showingSpeakers=true}else{B.style.visibility="hidden";B.style.overflow="hidden";A.style.overflow="hidden";if(isIPad){setTimeout(function(){B.style.visibility="hidden"},0)}else{B.style.visibility="hidden"}showingSpeakers=false;hideAddressBar()}}}function showMediaLibSearch(){if(showingMediaLibAlphaJump){showMediaLibAlphaJump()}if(document.getElementById){var B=document.getElementById("libsearchfield");if(!showingMediaLibSearch){B.style.visibility="visible";var A=document.getElementById("searchInput");if(A){A.focus()}searchInputTimer=setInterval(searchInputMonitor,300);showingMediaLibSearch=true}else{B.style.visibility="hidden";var A=document.getElementById("searchInput");A.value="";if(searchInputTimer){clearInterval(searchInputTimer);searchInputTimer=null}showingMediaLibSearch=false}}}function showMediaLibActions(B){if(document.getElementById){var A=document.getElementById("itemactions");currentActionItem=B;if(!showingMediaLibActions){hideAddressBar();A.style.visibility="visible";showingMediaLibActions=true}else{A.style.visibility="hidden";showingMediaLibActions=false;hideAddressBar()}}}function showMediaLibAlphaJump(){if(document.getElementById){var A=document.getElementById("alphajump");if(!showingMediaLibAlphaJump){hideAddressBar();A.style.display="block";A.style.visibility="visible";showingMediaLibAlphaJump=true}else{A.style.visibility="hidden";A.style.display="none";showingMediaLibAlphaJump=false;hideAddressBar()}}}function showCurrentPlaylistItem(){if(player.playlistPosition<playlistStart||player.playlistPosition>=(playlistStart+itemsPerPage)){var A=parseInt(player.playlistPosition/itemsPerPage);player.getPlaylistItems(A*itemsPerPage,itemsPerPage);showPlaylistItemOnPageLoad=true;return }if(!showingPlaylist){showPlaylist();setTimeout(showCurrentPlaylistItem,100);return }var B=document.getElementById("playlist_"+player.playlistPosition);if(B){window.scrollTo(0,B.offsetTop)}}function addBrowseHistoryEntry(){var A=new BrowseHistoryEntry();A.start=mediaLibStart;A.search=showingMediaLibSearchResults;if(!A.search){A.path=currentBrowsePath}else{A.path=currentSearchKeywords}browseHistory.push(A)}function navigateLibBack(){if(browseHistory.length<1){backToNowPlaying();return }var A=browseHistory.pop();if(!A.search){player.browseLibrary(A.path,A.start,itemsPerPage)}else{if(!showingMediaLibSearchResults){showingMediaLibSearchResults=true;if(document.getElementById){message=document.getElementById("libheadertitle");message.innerHTML="Search"}else{libheadertitle.innerHTML="Search"}}currentSearchKeywords=A.path;player.searchLibrary(A.path,A.start,itemsPerPage)}}function onAlbumArtChanged(A){if(A==""){A="images/no_artwork.jpg"}var C="";if(A!=""){C='<img id="artwork" src="'+A+'">'}var B=document.getElementById(albumArtCurrentName);B.innerHTML=C}function onAlbumArtLoaded(){var B=document.getElementById(albumArtCurrentName);var A=document.getElementById(albumArtNewName);if(isMobileSafari){B.style.webkitTransitionProperty="left";A.style.webkitTransitionProperty="left";B.style.webkitTransitionDuration="0.4s";A.style.webkitTransitionDuration="0.4s"}albumArtCurrentName=A.id;albumArtNewName=B.id;B.style.left="-320px";A.style.left="0px"}function onAlbumArtAnimationEnd(){var A=document.getElementById(albumArtNewName);if(isMobileSafari){A.style.webkitTransitionProperty="none"}A.style.left="320px"}function onRatingChanged(B){var A=B/20;for(i=1;i<=5;i++){var C=document.getElementById("star"+i);if(C){if(i<=A){C.className="starred"}else{C.className=""}}}}function searchInput_keyUp(){if(!showingMediaLibSearch){return }var B=document.getElementById("searchInput");if(B.value.length>2){currentSearchKeywords=B.value;player.searchLibrary(B.value,0,itemsPerPage)}else{var A=document.getElementById("libcontents");A.innerHTML=""}}function toggleControls(){var A=document.getElementById("subcontrols");hideAddressBar();if(!showingSubControls){A.style.visibility="visible";showingSubControls=true}else{A.style.visibility="hidden";showingSubControls=false}}function handleBrowseLibrary(A,B){hideAddressBar();if(showingMediaLib){addBrowseHistoryEntry()}player.browseLibrary(B,0,itemsPerPage)}function handlePlayItem(A,B){backToNowPlaying();player.playItem(B)}function handlePlayViewFromItem(A,B){backToNowPlaying();player.playItem(currentBrowsePath,B)}function handlePlaylistJump(A,B){backToNowPlaying();player.setPlaylistPosition(B)}function handleRating(A){currentRating=A;onRatingChanged(A);player.setRating(A)}function handleActionPlay(){player.playItem(currentActionItem);showMediaLibActions()}function handleActionAdd(){player.playlistAdd(currentActionItem);showMediaLibActions()}function handleSingleItemAdd(A,B){A.className="off";player.playlistAdd(B)}function handleSpeakerSelection(A){if(!useMultipleSpeakers){backToNowPlaying();player.selectSpeaker(A)}else{player.enableSpeaker(A,true)}}function toggleUseMultipleSpeakers(){useMultipleSpeakers=!useMultipleSpeakers;var B=document.getElementById("speakermsg");var A=document.getElementById("multiplespeakerbtn");A.setAttribute("enabled",useMultipleSpeakers);if(useMultipleSpeakers){B.innerHTML="Tap on a speaker name to toggle its audio on or off."}else{B.innerHTML="Tap on a speaker name to send all audio to that speaker."}if(useMultipleSpeakers){setCookie("useMultipleSpeakers","true",365)}else{deleteCookie("useMultipleSpeakers")}}function mediaLibPrevPage(){player.browseLibrary(currentBrowsePath,mediaLibStart-itemsPerPage,itemsPerPage,false)}function mediaLibNextPage(){player.browseLibrary(currentBrowsePath,mediaLibStart+itemsPerPage,itemsPerPage,false)}function mediaLibJumpToLetter(A){player.browseLibrary(currentBrowsePath,A,itemsPerPage,false);if(showingMediaLibAlphaJump){showMediaLibAlphaJump()}}function playlistPrevPage(){player.getPlaylistItems(playlistStart-itemsPerPage,itemsPerPage,false)}function playlistNextPage(){player.getPlaylistItems(playlistStart+itemsPerPage,itemsPerPage,false)}function setLocation(B,A){if(!isMobileSafari){return }if(A==null||A==true){navHistory.push(location.hash)}navCurrent=B;location.hash=navCurrent}function slideTo(A){setTimeout(function(){var D=100;var C=setInterval(B,0);function B(){D-=slideSpeed;if(D<=0){D=0;clearInterval(C)}var E=((100-D)/100)*A;scrollTo(0,E)}},0)}function setCookie(C,D,E){var A="";if(E){var B=new Date();B.setTime(B.getTime()+(E*24*60*60*1000));A="; expires="+B.toGMTString()}document.cookie=C+"="+D+A+"; path=/"}function getCookie(B){B+="=";var A=document.cookie.split(";");for(var D=0;D<A.length;D++){var C=A[D];while(C.charAt(0)==" "){C=C.substring(1,C.length)}if(C.indexOf(B)==0){return C.substring(B.length,C.length)}}return null}function deleteCookie(A){setCookie(A,"",-1)}function searchInputMonitor(){if(!showingMediaLibSearch){return }var B=document.getElementById("searchInput");if(B.value!=searchInput){searchInput=B.value;if(searchInput.length>2){currentSearchKeywords=searchInput;player.searchLibrary(searchInput,0,itemsPerPage)}else{var A=document.getElementById("libcontents");A.innerHTML=""}}}function uiMonitor(){if(!isMobileSafari){return }if(location.hash!=navCurrent){var A=location.hash.substr(navHash.length);if(A==navCurrent){navCurrent=location.hash;return }navCurrent=location.hash;if(navHistory.length>0&&location.hash==navHistory[navHistory.length-1]){navHistory.pop()}else{navHistory.push(location.hash)}if(A=="Media"){if(!showingMediaLib){showMediaLib(false)}}else{if(A=="Playlist"){if(!showingPlaylist){showPlaylist(false)}}else{if(A=="Speakers"){if(!showingSpeakers){showSpeakers(false)}}else{if(showingMediaLib){showMediaLib(false)}else{if(showingPlaylist){showPlaylist(false)}else{if(showingSpeakers){showSpeakers(false)}}}}}}}}function writeLog(C,B){if(!loggingEnabled){return }try{if(B){if(B.lineNumber){C+=": "+B.toString()+" at line "+B.lineNumber+" of "+B.fileName+"\nstack:\n"+B.stack}else{C+=": "+B.toString()}}console.log(C)}catch(A){}};